#include "defines.h"
#include "interrupt.h"
#include "serial.h"
#include "lib.h"

void trush()
{
  while (tstc())
    getc();
}

char *sendcmd(char *cmd)
{
  static char buf[32];
  puts(cmd);
  puts("\n");
  do {
    gets(buf);
  } while (buf[0] == '\0');
  return buf;
}

int get_ls_come() { return !strcmp(sendcmd("LS_COME"), "ON") ? 1 : 0; }
int get_ls_pass() { return !strcmp(sendcmd("LS_PASS"), "ON") ? 1 : 0; }
int get_rs_come() { return !strcmp(sendcmd("RS_COME"), "ON") ? 1 : 0; }
int get_rs_pass() { return !strcmp(sendcmd("RS_PASS"), "ON") ? 1 : 0; }
int get_us_push() { return !strcmp(sendcmd("US_PUSH"), "ON") ? 1 : 0; }
int get_ds_push() { return !strcmp(sendcmd("DS_PUSH"), "ON") ? 1 : 0; }

void mainloop()
{
  int ls_come, rs_come, ls_pass, rs_pass;

  while (1) {
    ls_come = get_ls_come();
    rs_come = get_rs_come();
    ls_pass = get_ls_pass();
    rs_pass = get_rs_pass();
    if (ls_come || rs_come) {
      sendcmd("CLOSE");
      while (!get_ds_push())
	;
      sendcmd("STOP");
    }
    if (ls_pass || rs_pass) {
      sendcmd("OPEN");
      while (!get_us_push())
	;
      sendcmd("STOP");
    }
    trush();
  }
}

int main(void)
{
  INTR_DISABLE; /* ̵ˤ */

#ifdef SIMULATOR
  extern int bss_start, ebss;

  memset(&bss_start, 0, (long)&ebss - (long)&bss_start);

  /* եȥߥ٥ */
  softvec_init();

  /* ꥢν */
  serial_init(SERIAL_DEFAULT_DEVICE);
#endif

#if 0
  puts("kozos boot succeed!\n");
#endif

  mainloop();

  /* ˤäƤʤ */

  return 0;
}
