#include "defines.h"
#include "interrupt.h"
#include "serial.h"
#include "lib.h"

void trush()
{
  while (tstc())
    getc();
}

char *sendcmd(char *cmd)
{
  static char buf[32];
  puts(cmd);
  puts("\n");
  do {
    gets(buf);
  } while (buf[0] == '\0');
  return buf;
}

int get_ls_come() { return !strcmp(sendcmd("LS_COME"), "ON") ? 1 : 0; }
int get_ls_pass() { return !strcmp(sendcmd("LS_PASS"), "ON") ? 1 : 0; }
int get_rs_come() { return !strcmp(sendcmd("RS_COME"), "ON") ? 1 : 0; }
int get_rs_pass() { return !strcmp(sendcmd("RS_PASS"), "ON") ? 1 : 0; }
int get_us_push() { return !strcmp(sendcmd("US_PUSH"), "ON") ? 1 : 0; }
int get_ds_push() { return !strcmp(sendcmd("DS_PUSH"), "ON") ? 1 : 0; }

int passing;

void set_passing()
{
  static int left_passing;
  static int right_passing;
  if (get_ls_come()) left_passing = 1;
  if (get_ls_pass()) left_passing = 0;
  if (get_rs_come()) right_passing = 1;
  if (get_rs_pass()) right_passing = 0;
  passing = left_passing || right_passing;
}

void mainloop()
{
  int passing_old;

  while (1) {
    passing_old = passing;
    set_passing();
    if (passing_old == passing) {
      if (passing) {
	sendcmd("LIGHTON");
	sendcmd("DUMMY");
	sendcmd("LIGHTOFF");
	sendcmd("DUMMY");
      }
      continue;
    }
    if (passing) {
      sendcmd("CLOSE");
      while (!get_ds_push()) {
	set_passing();
	sendcmd("LIGHTON");
	sendcmd("DUMMY");
	sendcmd("LIGHTOFF");
	sendcmd("DUMMY");
      }
      sendcmd("STOP");
    } else {
      sendcmd("OPEN");
      while (!get_us_push()) {
	set_passing();
	if (passing) {
	  sendcmd("CLOSE");
	  while (!get_ds_push())
	    set_passing();
	  sendcmd("STOP");
	  break;
	}
      }
      sendcmd("STOP");
    }
    trush();
  }
}

int main(void)
{
  INTR_DISABLE; /* ̵ˤ */

#ifdef SIMULATOR
  extern int bss_start, ebss;

  memset(&bss_start, 0, (long)&ebss - (long)&bss_start);

  /* եȥߥ٥ */
  softvec_init();

  /* ꥢν */
  serial_init(SERIAL_DEFAULT_DEVICE);
#endif

#if 0
  puts("kozos boot succeed!\n");
#endif

  mainloop();

  /* ˤäƤʤ */

  return 0;
}
